local CattleProduction = ...

CattleProduction:registerAssetProcessor("models/cattlefarm.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})

-- register cattle farm
CattleProduction:registerAssetId("models/cattlefarm.fbx/Prefab/CattlefarmPart", "CATTLE_V3_CATTLEFARM_PREFAB")
CattleProduction:registerAssetId("models/cattlefarm.fbx/Prefab/Construction_Steps", "CATTLE_V3_CATTLEFARM_CONSTRUCTION_PREFAB")

-- register cattle farm
CattleProduction:register({
	DataType = "BUILDING",
	Id = "CATTLE_V3_CATTLEFARM",
	Name = "CATTLE_V3_CATTLEFARM_NAME",
	Description = "CATTLE_V3_CATTLEFARM_DESC",
	BuildingType = "GENERAL",
	BuildingPartSetList = {
		{
			Name = "CATTLE_V3_CATTLEFARM_PARTSETLIST_NAME",
	                BuildingPartList = { "CATTLE_V3_CATTLEFARM_PART" }
                }
        }
})

CattleProduction:register({
	DataType = "BUILDING_PART",
	Id = "CATTLE_V3_CATTLEFARM_PART",
	ConstructionVisual = "CATTLE_V3_CATTLEFARM_CONSTRUCTION_PREFAB",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "CATTLE_V3_CATTLEFARM_PREFAB"
	},
	Cost = {
		RessourcesNeeded = {
			{ Resource = "WOOD", Quantity = 20 },
			{ Resource = "STONE", Quantity = 10 }
		}
	},
	AssetBuildingFunction = "CATTLE_V3_CATTLEFARM_FUNCTION"
})
CattleProduction:register({
		DataType = "BUILDING_FUNCTION_LIVESTOCK_FARM",
                Id = "CATTLE_V3_CATTLEFARM_FUNCTION",
		WorkerCapacity = 2,
		RelatedJob = { 
			Job = "SHEPHERD",
			Behavior = "WORK_BEHAVIOR"
		},
		ResourceProduced = {
			{ Resource = "J2BF8_CATTLE", Quantity = 1 }
		},
                SpawningLivestock = "PREFAB_LIVESTOCK_COW",
                SpawnLivestockButtonText = "CATTLE_V3_CATTLEFARM_SPAWN_TEXT",
                RemoveLivestockButtonText = "CATTLE_V3_CATTLEFARM_REMOVE_TEXT"
})
CattleProduction:registerPrefabComponent("models/cattlefarm.fbx/Prefab/CattlefarmPart", {
	DataType = "COMP_BUILDING_PART",
	HasBuildingZone = true,
	BuildingZone = { 12, 10 }
})

-- register grass clearing area
CattleProduction:registerPrefabComponent("models/cattlefarm.fbx/Prefab/CattlefarmPart", {
	DataType = "COMP_DIRT_RECTANGLE",
	Size = { 10, 8 }
})

-- register slaughter house
CattleProduction:registerAssetProcessor("models/slaughterhouse.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})

CattleProduction:registerAssetId("models/slaughterhouse.fbx/Prefab/SlaughterhousePart", "CATTLE_V3_SLAUGHTERHOUSE_PREFAB")
CattleProduction:registerAssetId("models/slaughterhouse.fbx/Prefab/Construction_Steps", "CATTLE_V3_SLAUGHTERHOUSE_CONSTRUCTION_PREFAB")

-- register slaughter house
CattleProduction:register({
	DataType = "BUILDING",
	Id = "CATTLE_V3_SLAUGHTERHOUSE",
	Name = "CATTLE_V3_SLAUGHTERHOUSE_NAME",
	Description = "CATTLE_V3_SLAUGHTERHOUSE_DESC",
	BuildingType = "GENERAL",
	BuildingPartSetList = {
		{
			Name = "CATTLE_V3_SLAUGHTERHOUSE_PARTSETLIST_NAME",
                	BuildingPartList = { "CATTLE_V3_SLAUGHTERHOUSE_PART" }
                }
        }
})

CattleProduction:register({
	DataType = "BUILDING_PART",
	Id = "CATTLE_V3_SLAUGHTERHOUSE_PART",
	ConstructionVisual = "CATTLE_V3_SLAUGHTERHOUSE_CONSTRUCTION_PREFAB",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "CATTLE_V3_SLAUGHTERHOUSE_PREFAB"
	},
	Cost = {
		RessourcesNeeded = {
			{ Resource = "WOOD", Quantity = 10 }
		}
	},
	AssetBuildingFunction = "CATTLE_V3_SLAUGHTERHOUSE_FUNCTION"
})
CattleProduction:register({
		DataType = "BUILDING_FUNCTION_WORKPLACE",
                Id = "CATTLE_V3_SLAUGHTERHOUSE_FUNCTION",
		WorkerCapacity = 2,
		RelatedJob = { 
			Job = "SHEPHERD",
			Behavior = "WORK_BEHAVIOR"
		},
		InputInventoryCapacity = {
			{ Resource = "J2BF8_CATTLE", Quantity = 50 }
		},
		ResourceListNeeded = {
			{ Resource = "J2BF8_CATTLE", Quantity = 1 }
		},
		ResourceProduced = {
			{ Resource = "J2BF8_BEEF", Quantity = 1 }
		}
})
CattleProduction:registerPrefabComponent("models/slaughterhouse.fbx/Prefab/SlaughterhousePart", {
	DataType = "COMP_BUILDING_PART",
	HasBuildingZone = true,
	BuildingZone = { 7, 7 }
})

CattleProduction:register({
		DataType = "BUILDING_FUNCTION_WORKPLACE",
                Id = "SMOKE_HOUSE_V3_BEEF_FUNCTION",
                Name = "SMOKE_HOUSE_V3_BEEF_FUNCTION_NAME",
                TypeList = { "FOOD" },
                IsOverrideCapacity = true,
                CapacityPerSlot = 50,
		WorkerCapacity = 1,
                RelatedJob = { Job = "SHEPHERD", Behavior = "WORK_BEHAVIOR" },
                InputInventoryCapacity = {
			{ Resource = "J2BF8_BEEF", Quantity = 50 },
                	{ Resource = "SALT2", Quantity = 50 },
                	{ Resource = "WOOD", Quantity = 50 }
                },
                ResourceListNeeded = {
                	{ Resource = "J2BF8_BEEF", Quantity = 1 },
                	{ Resource = "SALT2", Quantity = 1 },
                	{ Resource = "WOOD", Quantity = 2 }
                },
                ResourceProduced = {
			{ Resource = "SMOKE_HOUSE_V3_SALTING", Quantity = 4 }
                }
})

CattleProduction:override({
    Id = "SMOKE_HOUSE_V3_FUNCTION_LIST",
    AssetFunctionList = {
                Action = "APPEND",
		"SMOKE_HOUSE_V3_BEEF_FUNCTION"
    }
})

-- Building function cow to leather
CattleProduction:register({
    DataType = "BUILDING_FUNCTION_WORKPLACE",
    Id = "TANNERY_FUNCTION_COW_TO_LEATHER",
	Name = "TANNERY_FUNCTION_COW_TO_LEATHER_NAME",
    WorkerCapacity = 2,
	RelatedJob = { Job = "TANNER", Behavior = "WORK_BEHAVIOR" },
	InputInventoryCapacity = {{ Resource = "J2BF8_CATTLE", Quantity = 20 }},
	ResourceListNeeded = {{ Resource = "J2BF8_CATTLE", Quantity = 2 }},
	ResourceProduced = {{ Resource = "LEATHER", Quantity = 4 }}	
})

CattleProduction:override({
    Id = "TANNERY_FUNCTION_LIST",
    AssetFunctionList = {
                Action = "APPEND",
		"TANNERY_FUNCTION_COW_TO_LEATHER"
    }
})
